#set_property CLOCK_DEDICATED_ROUTE BACKBONE [get_nets dppt_zcu102_wrapper/clk_wiz_0/inst/clk_in1_sys_mb_ddr3_clk_wiz_0_0]
#set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets design_1_i/clk_wiz_0/inst/clkin1_ibufds/O]

##-----ZCU102-----##
set_property PACKAGE_PIN K20 [get_ports IIC_MAIN_scl_io]
set_property IOSTANDARD LVCMOS33 [get_ports IIC_MAIN_scl_io]
set_property PACKAGE_PIN L20 [get_ports IIC_MAIN_sda_io]
set_property IOSTANDARD LVCMOS33 [get_ports IIC_MAIN_sda_io]


## Refclk
set_property PACKAGE_PIN G8 [get_ports mgtrefclk0_pad_p_in]
set_property PACKAGE_PIN G7 [get_ports mgtrefclk0_pad_n_in]
#create_clock -period 3.703 -name mgtrefclk0_pad_p_in [get_ports mgtrefclk0_pad_p_in]

set_property PACKAGE_PIN L8 [get_ports mgtrefclk1_pad_p_in]
set_property PACKAGE_PIN L7 [get_ports mgtrefclk1_pad_n_in]
#create_clock -period 3.703 -name mgtrefclk1_pad_p_in [get_ports mgtrefclk1_pad_p_in]


#AUX TX
set_property PACKAGE_PIN AA2 [get_ports tx_hpd] 
set_property IOSTANDARD LVCMOS18 [get_ports tx_hpd]
set_property PULLDOWN true [get_ports tx_hpd]
#LVCMOS18
#set_property IOSTANDARD LVDS [get_ports aux_tx_io_n] 
#set_property IOSTANDARD LVDS [get_ports aux_tx_io_p]
#set_property PACKAGE_PIN Y12 [get_ports aux_tx_io_p]
set_property IOSTANDARD LVCMOS18 [get_ports aux_tx_data_en_out_n_0] 
set_property IOSTANDARD LVCMOS18 [get_ports aux_tx_data_in_0] 
set_property IOSTANDARD LVCMOS18 [get_ports aux_tx_data_out_0] 

set_property PACKAGE_PIN AA1 [get_ports {aux_tx_data_en_out_n_0}]
set_property PACKAGE_PIN AC2 [get_ports aux_tx_data_in_0]
set_property PACKAGE_PIN W4 [get_ports aux_tx_data_out_0] 

#AUX RX
#set_property PACKAGE_PIN AC2 [get_ports rx_hpd]
#set_property IOSTANDARD LVCMOS18 [get_ports rx_hpd]
#set_property PULLDOWN true [get_ports rx_hpd]

#set_property IOSTANDARD LVDS [get_ports aux_rx_io_n]
#set_property IOSTANDARD LVDS [get_ports aux_rx_io_p]
#set_property PACKAGE_PIN AC6 [get_ports aux_rx_io_n]

# Misc
#set_property PACKAGE_PIN M14 [get_ports {B_SOURCE_AUX_DE[0]}]
set_property PACKAGE_PIN AC1 [get_ports {B_SOURCE_AUX_DE[0]}]
set_property IOSTANDARD LVCMOS18 [get_ports {B_SOURCE_AUX_DE[0]}]

#set_property IOSTANDARD LVCMOS18 [get_ports {B_SOURCE_EN[0]}]
#set_property PACKAGE_PIN V3 [get_ports {B_SOURCE_EN[0]}]

set_property IOSTANDARD LVCMOS18 [get_ports {B_SOURCE_RST[0]}]
#set_property PACKAGE_PIN V4 [get_ports {B_SOURCE_RST[0]}]
set_property PACKAGE_PIN U8 [get_ports {B_SOURCE_RST[0]}]



# DP159 Connections
#set_property PACKAGE_PIN AC1 [get_ports {dp159_OE}]
#set_property IOSTANDARD LVCMOS18 [get_ports {dp159_OE}]

#set_property PACKAGE_PIN W5 [get_ports dp159_iic_scl_io]
#set_property IOSTANDARD LVCMOS18 [get_ports dp159_iic_scl_io]
#set_property PACKAGE_PIN W4 [get_ports dp159_iic_sda_io]
#set_property IOSTANDARD LVCMOS18 [get_ports dp159_iic_sda_io]

# SPI Connections - To program PLL on DP159 FMC
#set_property IOSTANDARD LVCMOS18 [get_ports spi_0_io0_io]
#set_property PACKAGE_PIN V6 [get_ports spi_0_io0_io]

#set_property IOSTANDARD LVCMOS18 [get_ports spi_0_io1_io]
#set_property PACKAGE_PIN L11 [get_ports spi_0_io1_io]

#set_property IOSTANDARD LVCMOS18 [get_ports spi_0_sck_io]
#set_property PACKAGE_PIN T6 [get_ports spi_0_sck_io]

#set_property IOSTANDARD LVCMOS18 [get_ports {spi_0_ss_io}]
#set_property PACKAGE_PIN T7 [get_ports {spi_0_ss_io}]


set_min_delay -from [get_pins -filter {REF_PIN_NAME=~ C} -of_objects [get_cells -hierarchical -filter {NAME=~ */drp_control_b0gtcommon_inst/DRPADDR_reg[*]}]] -to [get_pins -filter {REF_PIN_NAME=~ DRPADDR[*]} -of_objects [get_cells -hierarchical -filter {name=~*GTHE4_COMMON_PRIM_INST}]] 0.300
set_min_delay -from [get_pins -filter {REF_PIN_NAME=~ C} -of_objects [get_cells -hierarchical -filter {NAME=~ */drp_control_b0gtcommon_inst/DRPDI_reg[*]}]] -to [get_pins -filter {REF_PIN_NAME=~ DRPDI[*]} -of_objects [get_cells -hierarchical -filter {name=~*GTHE4_COMMON_PRIM_INST}]] 0.300
set_min_delay -from [get_pins -filter {REF_PIN_NAME=~ C} -of_objects [get_cells -hierarchical -filter {NAME=~ */drp_control_b0gtcommon_inst/DRPEN_reg}]] -to [get_pins -filter {REF_PIN_NAME=~ DRPEN} -of_objects [get_cells -hierarchical -filter {name=~*GTHE4_COMMON_PRIM_INST}]] 0.300
set_min_delay -from [get_pins -filter {REF_PIN_NAME=~ C} -of_objects [get_cells -hierarchical -filter {NAME=~ */drp_control_b0gtcommon_inst/DRPWE_reg}]] -to [get_pins -filter {REF_PIN_NAME=~ DRPWE} -of_objects [get_cells -hierarchical -filter {name=~*GTHE4_COMMON_PRIM_INST}]] 0.300



# GT setting over write. Only for GTHE4. This xdc file has to be read at very last.
# This xdc file has to be read at very last. Current ZCU102 board has twisted GT pins assigned.
# Following constraints can over write the settng and can take user defined location instead.
set_property LOC "" [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe4_channel_inst[3].GTHE4_CHANNEL_PRIM_INST}]
set_property LOC "" [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe4_channel_inst[1].GTHE4_CHANNEL_PRIM_INST}]
set_property LOC "" [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe4_channel_inst[0].GTHE4_CHANNEL_PRIM_INST}]
set_property LOC "" [get_cells -hierarchical -filter {NAME =~ *gen_channel_container[26].*gen_gthe4_channel_inst[2].GTHE4_CHANNEL_PRIM_INST}]

## DP TX pins
set_property PACKAGE_PIN   G3  [get_ports { phy_txn_out[0]}]
set_property PACKAGE_PIN   H5  [get_ports { phy_txn_out[1]}]
set_property PACKAGE_PIN   F5  [get_ports { phy_txn_out[2]}]
set_property PACKAGE_PIN   K5  [get_ports { phy_txn_out[3]}]
set_property PACKAGE_PIN   G4  [get_ports { phy_txp_out[0]}]
set_property PACKAGE_PIN   H6  [get_ports { phy_txp_out[1]}]
set_property PACKAGE_PIN   F6  [get_ports { phy_txp_out[2]}]
set_property PACKAGE_PIN   K6  [get_ports { phy_txp_out[3]}]


## DP RX pins
#set_property PACKAGE_PIN   H1  [get_ports { phy_rxn_in[0]}]
#set_property PACKAGE_PIN   J3  [get_ports { phy_rxn_in[1]}]
#set_property PACKAGE_PIN   F1  [get_ports { phy_rxn_in[2]}]
#set_property PACKAGE_PIN   K1  [get_ports { phy_rxn_in[3]}]
#set_property PACKAGE_PIN   H2  [get_ports { phy_rxp_in[0]}]
#set_property PACKAGE_PIN   J4  [get_ports { phy_rxp_in[1]}]
#set_property PACKAGE_PIN   F2  [get_ports { phy_rxp_in[2]}]
#set_property PACKAGE_PIN   K2  [get_ports { phy_rxp_in[3]}]

set_property IOSTANDARD DIFF_SSTL12 [get_ports Si570_CLK_clk_p]
set_property PACKAGE_PIN AL8 [get_ports Si570_CLK_clk_p]
set_property PACKAGE_PIN AL7 [get_ports Si570_CLK_clk_n]

create_clock -period 40.69 [get_ports Si570_CLK_clk_p]


set_property IOSTANDARD LVCMOS18 [get_ports pwr[0]]
set_property PACKAGE_PIN W5 [get_ports pwr[0]]
